* ** MDESich.prg ***
* ** Sicherung der Daten auf dem MDE
* ** SaarForst, RMK, Februar, Juni, November 2014
* ** Nationalparkamt Hunsrueck-Hochwald, Dezember 2016
* ** Nationalparkamt Hunsrueck-Hochwald, April 2019
#include "minigui.ch"
Function Main
set century on
set date GERMAN
set language to german
set codepage to german
set autoshare to 2
public mverzeichnis := diskname() + ":" + dirname() + "\"
public mquellverzeichnis := diskname() + ":" + dirname() + "\"
public munterverz := .F.
public mencrypt := .F.
public mschluessel := "geheim"
public maFiles
public mzielverzeichnis := "C:\"
public mpraefix := "Sicherung-"
if file(mverzeichnis + "MDEsich.ini")
   mspeicherstring = filestr(mverzeichnis + "MDEsich.ini")
   mquellverzeichnis = token(mspeicherstring,",",2,0)
   mzielverzeichnis = token(mspeicherstring,",",3,0)
   mpraefix = token(mspeicherstring,",",4,0)
   if token(mspeicherstring,",",5,0) = "ja"
      munterverz = .T.
   else
      munterverz = .F.
   endif
   if token(mspeicherstring,",",6,0) = "ja"
      mencrypt = .T.
   else
      mencrypt = .F.
   endif
endif
if file(mverzeichnis + "Schluessel.txt")
   mschluessel = filestr(mverzeichnis + "Schluessel.txt")
else
	strfile(mschluessel,mverzeichnis + "Schluessel.txt")
endif	

    DEFINE WINDOW Win_1 ;
        AT 0,0 ;
        WIDTH 500 ;
        HEIGHT 350 ;
        TITLE 'Sichern mobil erhobener Aufnahmedaten' ;
        MAIN 
        DEFINE MAIN MENU
           POPUP "Datei"
             ITEM 'Quellverzeichnis auswhlen' ACTION mquellverzeichnis := getfolder("Quellverzeichnis auswhlen") + "\"
             ITEM 'Zielverzeichnis auswhlen' ACTION mzielverzeichnis := getfolder("Zielverzeichnis auswhlen") + "\"
             ITEM 'Einstellungen speichern' ACTION fspeicher()
            END POPUP
           POPUP "Hilfe"
             item 'Hilfedatei lesen' ACTION fhilfe()
             item 'ber ...' ACTION msgbox("MDESich 3.0, Nationalparkamt Hunsrck-Hochwald, Stand April 2019")
           END POPUP
        END MENU
 

    @ 5,150 IMAGE Image_1 ;
            PICTURE 'MDEsich.jpg' ;
            WIDTH 320 ;
            HEIGHT 100 
            
 @ 140,20 PROGRESSBAR Progress_1 RANGE 1,100 Width 450 Height 15
 @ 180,20 LABEL Label_1 VALUE 'Dateinamen-Prfix' 
 @ 175,150  Textbox TEXT_1 value  mpraefix width 140  on change mpraefix := this.value
 @ 215,20 CHECKBOX Checkbox_1 Caption "Unterverzeichnisse einschliessen" Width 240 Value munterverz on change munterverz := this.value 
 @ 250,20 CHECKBOX Checkbox_2 Caption "Archiv verschlsseln"             Width 240 Value mencrypt on change mencrypt := this.value 

 
    @200,370 Button Knopf_1 Caption 'Los gehts!'  width 100 height 75 ACTION feinpacken()
    Win_1.Knopf_1.enabled := .T.

END WINDOW
   ACTIVATE WINDOW Win_1
Return
***************************************************************************************
function feinpacken
fspeicher() // Konfiguration sichern
// Plausibilitten prfen und Parameter wegschreiben
if len(mquellverzeichnis) < 3
   playexclamation()
   msginfo("Bitte zuerst das Quellverzeichnis konfigurieren","Fehlermeldung")
   return
endif
if len(mzielverzeichnis) < 3
   playexclamation()
   msginfo("Bitte zuerst das Ziel konfigurieren","Fehlermeldung")
   return
endif
if .not. file(mzielverzeichnis + "*.*")
   playexclamation()
   msginfo("Der Zieldatentrger " + mzielverzeichnis + " wurde nicht erkannt!","Fehlermeldung")
   return
endif
*** hier beginnt die stille Phase ***
Win_1.Progress_1.Value := 10 // mit fiktiven 10 Prozent beginnen
// Archivname berechnen
marchivname = getusername() + "_" + alltrim(mpraefix) + "_" + str(year(date()),4,0) + "-" + strzero(month(date()),2,0) + "-" + strzero(day(date()),2,0) + "-"
marchivname = marchivname + left(time(),2) + substr(time(),4,2)
* prfen, ob die Dateien vorhanden sind,
* ist alles OK, Batch ergnzen.
use Dateiliste
set print to Packen.bat
set console off
set print on
?? "@echo off"
? "SET ARCHIVNAME=" + chr(34) + marchivname + ".zip" + chr(34) // zur Verwendung in aufgerufenen Routinen
? "CALL Vorlauf.BAT"
? left(mverzeichnis,2)
? "CD " + substr(mverzeichnis,3,500)
go top
do while .not. eof()
   if munterverz = .T.
      maFiles := DirectoryRecurse(mquellverzeichnis + alltrim(Dateiname))
      i := len(mafiles)
	  do while i > 0
	  Win_1.Progress_1.Value := round((1 - (i / len(mafiles))),2) * 100 // ganzzahlige Prozentzahl berechnen
         if fpruef(mafiles[i,1]) = .F.
		    return
         endif
         i --
      enddo	  
      ? "7z a -r "
   else
      maFiles := Directory(mquellverzeichnis + alltrim(Dateiname))
      i := len(mafiles)
	  do while i > 0
	     Win_1.Progress_1.Value := round((1 - (i / len(mafiles))),2) * 100 // ganzzahlige Prozentzahl berechnen
         if fpruef(mquellverzeichnis + mafiles[i,1]) = .F.
  	        return
         endif
         i --
      enddo	  
      ? "7z a "
   endif
   ?? chr(34) + mverzeichnis + marchivname + ".zip" + chr(34) 
   if mencrypt = .T.
      ?? " -p" + alltrim(mschluessel)
	endif  
   ?? " " + chr(34) + alltrim(mquellverzeichnis + Dateiname) + chr(34) + " "
   skip
enddo
? "Call Nachlauf.bat"
? "Echo."
? "Echo Die Archivdatei wird kopiert..."
? "Echo."
? "copy " + chr(34) + mverzeichnis + marchivname + ".zip" + chr(34) + " " + chr(34) + mzielverzeichnis + marchivname + ".zip" + chr(34) + " /Y"
?
set print off
set print to
use
Win_1.Progress_1.Value := 100 // Am Ende immer 100 Prozent
millisec(500)
win_1.Progress_1.release
EXECUTE FILE "Packen.bat" WAIT
millisec(1500)
filedelete(mverzeichnis + marchivname)
filedelete(mverzeichnis + marchivname + ".zip")
if file(mzielverzeichnis + marchivname + ".zip")
   mendemeldung = "Die Datensicherung war erfolgreich."
   if drivetype(left(mzielverzeichnis,1)) = 2
      mendemeldung = Mendemeldung + " Den Wechseldatentrger bitte sicher entfernen."
   endif
   msginfo(mendemeldung,"Status")
   quit
else
   playexclamation()
   msginfo("Datensicherung fehlgeschlagen!","Horrormeldung")
endif
return
***************************************************************************************
Function fspeicher
if len(alltrim(mpraefix)) < 1 // keinen Leerstring abspeichern
   mpraefix = "Sicherung-"
endif
mspeicherstring = "Konfiguration," 
mspeicherstring = mspeicherstring + alltrim(mquellverzeichnis) + ","
mspeicherstring = mspeicherstring + alltrim(mzielverzeichnis) + ","
mspeicherstring = mspeicherstring + alltrim(mpraefix) + ","
if munterverz = .T.
   mspeicherstring = mspeicherstring + "ja,"
else
   mspeicherstring = mspeicherstring + "nein,"
endif
if mencrypt = .T.
   mspeicherstring = mspeicherstring + "ja,"
else
   mspeicherstring = mspeicherstring + "nein,"
endif
mspeicherdatei = mverzeichnis + "MDEsich.ini"
set print to &mspeicherdatei
set print on
?? mspeicherstring
set print off
set print to
return
***************************************************************************************
function fhilfe
mhilfedatei = mverzeichnis + "MDESich_Hilfe.pdf"
if file(mhilfedatei)
    EXECUTE FILE mhilfedatei 
 else
   msginfo("Die Hilfedatei MDESich_HILFE.PDF fehlt!","Horrormeldung")
endif
return
***************************************************************************************
function fpruef
parameters mpruefdatei
mfhnr = fopen(mpruefdatei,16)
merror = ferror()
fclose(mfhnr)
if merror <> 0
   playexclamation()
   msginfo("Fehler " + str(merror,2,0) + " ,die Datei " + mpruefdatei + " ist nicht geschlossen oder nicht vorhanden.","Fehlermeldung")
   set print off
   set print to
   return .F.
else
   fclose(mfhnr)
endif
return .T.
   
***************************************************************************************************   
   
function fdummy
Return